Name:		hp-igb
Version:	6.8.5
Release:	2.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://support.intel.com/support/go/igb.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	HP Intel Gigabit Ethernet driver (igb)

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -f %{SOURCE1} -x %flav -b}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) Gigabit Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: HP Intel Gigabit Ethernet driver (igb)
Group: System/Kernel

%description KMP
Intel(R) Gigabit Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the HP Intel Gigabit Ethernet driver (igb)

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override igb * weak-updates/%{name}" > %{name}.conf
echo "add_drivers+=\" igb \"" > %{name}-oob.conf

%build
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
        make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/igb.7 > source/igb.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
        make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} install

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/igb.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/igb.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

install -d %{buildroot}%{_sysconfdir}/dracut.conf.d/
install %{name}-oob.conf %{buildroot}%{_sysconfdir}/dracut.conf.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/igb.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf
%{_sysconfdir}/dracut.conf.d/%{name}-oob.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/igb.7.gz
%doc source/COPYING source/README

%changelog
* Wed Sep 23 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 6.2.5-1
- Add RHEL8.3 support.

* Mon Aug 10 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 6.2.4-1
- Add SLES15 SP2 support

* Mon Jun 24 2019 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.42
- This driver fixes an issue of driver crash with ethtool command.
- This driver fixes an issue of Klocwork hits.
- Added RHEL7u6 Support.
- Added SLES12SP4 Support.

* Wed Aug 08 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.19-0[rhel6.10, rhel7u5], 5.3.5.15-7[For other OSs]
- Added RHEL6.10 Support.
- Added RHEL7.5 Support.

* Thu Jul 26 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.15-7
- This driver fixes the Spectre/Meltdown issue.
- Added SLES15 Support.

* Wed May 16 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.15-4
- Fixed build on updated kernels of SLES12SP2

* Mon Sep 18 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.12
- Fix for the issue of unable to set MTU value more than 1500 in SUSE12SP3 with Intel NICs

* Fri Jul 28 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.9xxz-3
- Added SLES12SP3 support
- Added RHEL 7.4 support

* Tue Mar 21 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.7-8[rhel6u9], 5.3.5.7-1[For other OSs]
- Added SLES12SP2 support
- Added RHEL 7.3 support

* Mon Jun 06 2016  HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.5.3-1
- Added RHEL 6.8 support
- Fix the issue of getting crash dump when loading igb module(modprobe igb)
- Fix unable to disable the offload property in rhel6u6
